import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

public class Main {
    public static void main(String[] args) {
        try {
            SAXParserFactory factory = SAXParserFactory.newInstance();
            SAXParser saxParser = factory.newSAXParser();

            File file = new File(args[1]);

            if (file.exists()) {
                file.delete();
            }
            file.createNewFile();

            FileWriter fw = new FileWriter(file.getAbsoluteFile());
            final BufferedWriter bw = new BufferedWriter(fw);


            DefaultHandler handler = new DefaultHandler() {

                @Override
                public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
                    try {
                        bw.write("<" + qName);
                        for(int i = 0; i<attributes.getLength(); i++) {
                             bw.write(" "+attributes.getQName(i)+"=\""+attributes.getValue(i)+"\"");
                        }
                        bw.write(">");
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }

                @Override
                public void endElement(String uri, String localName, String qName) throws SAXException {
                    try {
                        bw.write("</" + qName + ">");
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }

                @Override
                public void characters(char ch[], int start, int length) throws SAXException {
                    try {
                        bw.write(new String(ch, start, length));
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }

            };
            saxParser.parse(args[0], handler);

            bw.close();

        } catch (ParserConfigurationException e) {
            e.printStackTrace();
        } catch (SAXException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }


    }
}
