#!/usr/bin/perl

# Ouverture des fichiers input et output
open(FICH_IN, '<', '../input/dummyPad.html') or die $!;
open(FICH_OUT, '+>', '../intermediaire.xml') or die $!;

$insideMeta = 0;
$insideImportant = 0;
$insideExemple = 0;
$insideDefinition = 0;
$insideAttention = 0;

print FICH_OUT "<root>";

while($_ = <FICH_IN>)
{
  #print "\nligne courante : " . $_;

  $isDone = 0;
  
  # NIVEAUX DE TITRES
  if ($_ =~ /(={1,6})\s(.*)?\s\1/) {
    $title_lvl = length $1;
    print FICH_OUT '<h' . $title_lvl . '>' . $2 . '</h' . $title_lvl . '>'; 
    $isDone = 1;
  }

  # BLOC DE META-DONNEES
  if ($_ =~ /\{#/) {
    $insideMeta = 1;
    print FICH_OUT '<meta>'; 
    $isDone = 1;
  }
  
  if ($_ =~ /#}/) {
    $insideMeta = 0;
    print FICH_OUT '</meta>';
    $isDone = 1;
  }
  
  if ($insideMeta == 1)
  {	
    if ($_ =~ /\#([a-z]{1,15})\s([^\#]+)/g)
    {
      print FICH_OUT "<" . $1 . ">" . $2 . "</" . $1 . ">";
    }
    $isDone = 1;
  }
  
  # BLOC IMPORTANT
  if ($_ =~ /.*\$}/ && !($_ =~ /{\$.*/)) {
    $insideImportant = 0;
    print FICH_OUT '</important>';
    $isDone = 1;
  } 
  
  if ($insideImportant == 1) {
      print FICH_OUT $_;
      $isDone = 1;
    }
  
  if ($_ =~ /{\$.*/) {
    $insideImportant = 1;
    print FICH_OUT '<important>'; 
    $isDone = 1;
  } 
  
  # BLOC EXEMPLE
  if ($_ =~ /.*-}/ && !($_ =~ /{-.*/)) {
    $insideExemple = 0;
    print FICH_OUT '</exemple>';
    $isDone = 1;
  } 
  
  if ($insideExemple == 1) {
      print FICH_OUT $_;
      $isDone = 1;
    }
  
  if ($_ =~ /{-.*/) {
    $insideExemple = 1;
    print FICH_OUT '<exemple>'; 
    $isDone = 1;
  } 
  
  # BLOC DEFINITION
  if ($_ =~ /.*:}/ && !($_ =~ /{:.*/)) {
    $insideDefinition = 0;
    print FICH_OUT '</definition>';
    $isDone = 1;
  } 
  
  if ($insideDefinition == 1) {
      print FICH_OUT $_;
      $isDone = 1;
    }
  
  if ($_ =~ /{:.*/) {
    $insideDefinition = 1;
    print FICH_OUT '<definition>'; 
    $isDone = 1;
  } 
  
  # BLOC attention
  if ($_ =~ /.*!}/ && !($_ =~ /{!.*/)) {
    $insideAttention = 0;
    print FICH_OUT '</attention>';
    $isDone = 1;
  } 
  
  if ($insideAttention == 1) {
      print FICH_OUT $_;
      $isDone = 1;
    }
  
  if ($_ =~ /{!.*/) {
    $insideAttention = 1;
    print FICH_OUT '<attention>'; 
    $isDone = 1;
  } 
  
  if ($isDone == 0) { # Si la ligne n'a pas été traitée (rien de spécial détecté) on l'affiche telle quelle
    print FICH_OUT $_;
  }
  
} # FIN DE LA BOUCLE DANS LE FICHIER

print FICH_OUT "</root>";

close(FICH_IN);
close(FICH_OUT);