<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output indent="yes"/>
    
    <xsl:template match="map">
        <xsl:processing-instruction name="oxygen">
            RNGSchema="http://scenari.utc.fr/hdoc/schemas/xhtml/hdoc1-xhtml.rng" type="xml" 
        </xsl:processing-instruction>
        <html>
            <head> <title> <xsl:value-of select="node[1]/@TEXT"/></title></head>
            <body> <xsl:apply-templates select="*"/> </body>
        </html>
    </xsl:template>
    
    <xsl:template match="node[child::attribute[@name='content' and @value='true']]" priority="20">
        <text> <xsl:value-of select="@TEXT"/></text>
    </xsl:template>
    
    <xsl:template match="node[icon[@BUILTIN='info']]" priority="20">
        <text> <xsl:value-of select="@TEXT"/></text>
        
    </xsl:template>
    
    <xsl:template match="node[1]" priority="5">
        <section>
            <header>
                <h1><xsl:value-of select="@TEXT"/></h1>
                <xsl:apply-templates select="*"/>
            </header>
        </section>
    </xsl:template>
    
    <xsl:template match="node[1]/node" priority="5">
        <section>
            <header>
                <h1><xsl:value-of select="@TEXT"/></h1>
                <xsl:apply-templates select="*"/>
            </header>
        </section>
    </xsl:template>

    <xsl:template match="node" priority="1">
        <div>
            <h6><xsl:value-of select="@TEXT"/></h6>
            <xsl:apply-templates select="*"/>
        </div>   
    </xsl:template>
    
</xsl:stylesheet>
