// Setup code :
function file_setup()
{
	file_loadUploadedFiles();
	file_uploadingSetup();

	$(".file_list").selectable();
	$(".file_bloc").accordion(
	{
		collapsible: true,
		active : false,
		activate: function( event, ui ) 
		{
			ui.oldHeader.parent().find(".ui-selected").removeClass("ui-selected");
		}
	});
}

//---------------------------------------------------------------------------------------------------------------------------------------------------------------//
var bloc_id = 0;
var files = new Array();

// Class File
function File(name, formats)
{
	// Attributes :
	this.self = this;
	this.name = name; // The name of the "file" as it is a unique content, basicaly each conversion have the same name.
	this.allFormat = formats; // There will be the list of each format in which this file has been converted.
	this.id = bloc_id++; // Just an id for the blocs.
	this.file_bloc = $("#file_bloc_list").append(
	'<div class="file_bloc" id="'+this.id+'_file_bloc">'+
		'<h3>'+name+'</h3>'							 +
		'<div class="file_bloc_content">'			 +
			'<div class="file_list"/>'				 +
		'</div>'									 +
	'</div>');
	
	// Methods : 	
	this.addFormat = function(format) // Add a file format to the list.
	{
		if(format[0] != this.allFormat[0][0])
		{
			$("#"+this.id+"_file_bloc .file_bloc_content .file_list").append("<li name=\""+format[0]+"\"><span class=\"file_name\">"+format[0]+"/"+this.name+"."+format[1]+"</span></li>");
		}
		else
		{
			$("#"+this.id+"_file_bloc .file_bloc_content .file_list").append("<li name=\""+format[0]+"\"><span class=\"file_name\">"+format[0]+"/"+this.name+"."+format[1]+"</span><span class=\"original_tag\">*</span></li>");
		}
	}
	
	this.setOriginal = function(format) // Change the original format.
	{
		$("#"+this.id+"_file_bloc .file_bloc_content .file_list li .original_tag").remove();
		$("#"+this.id+"_file_bloc .file_bloc_content .file_list").children("[name='"+format[0]+"']").append("<span class=\"original_tag\">*</span>");
		this.allFormat.splice(this.allFormat.indexOf(format),1);
		this.allFormat.unshift(format);
	}
	
	this.getMetaInf = function() // Returns a JSON array describing the filebloc.
	{
		var str = "{ \"name\" : \""+this.name+"\", \"formats\" : [";
		var i =0;
		for(i = 0; i < this.allFormat.length; i++)
		{
			if(i!=0)
				str+=",";
				str += "[\""+this.allFormat[i][0]+"\",\""+this.allFormat[i][1]+"\"]";
		}
		str += "] }";
		return str;
	}
	
	this.validateMeta = function() // Checks if each file described in the metainf currently loaded are actualy on the server.
	{
		var i=0;
		var err = false;
		for (i = 0; i < this.allFormat.length; i++)
		{
			if(!file_fileExists(this.allFormat[i][0]+"/"+this.name+"."+this.allFormat[i][1]))
			{
				this.allFormat.splice(i,1);
				err = true;
			}
		}
		if(err)
			file_updateMetaInf();
		if(this.allFormat.length == 0)
			file_removeFileBloc(this);
	}

	
	this.getSelected = function() // Returns an array with all the selected files in the bloc
	{
		var list = new Array();
		$("#"+this.id+"_file_bloc").find(".ui-selected").each(function()
		{
			list.push($(this).find(".file_name").html());
		});
		return list;
	}
	
	var i=0;
	for (i = 0; i < this.allFormat.length; i++)
	{
		this.addFormat(this.allFormat[i]);
	}
	
	files.push(this);
		
	return this;
}

function file_removeFileBloc(fb)
{
	files.splice(files.indexOf(fb),1);
	delete fb;
	
	file_updateMetaInf();
}
// This checks the validity of the meta inf for each file :
function file_checkMetaInf()
{
	for(i = 0; i < files.length; i++)
	{
		files[i].validateMeta();
	}
}

// This returns the list of all actual file selected :
function file_getSelected()
{
	var list = new Array();
	for(i = 0; i < files.length; i++)
	{
		list = list.concat(files[i].getSelected());
	}
	return list;
}

// This will get the "uploads.inf" datas that describe all the files that are currently uploaded on the server.
function file_loadUploadedFiles()
{	
	$.ajaxSetup({async: false});
	$.post( "php/uploadmeta.php", {"action" : "get"})
	.done(function(message) 
	{
		var list = $.parseJSON(message);
		if(list.success)
		{
			var filelist = $.parseJSON(list.filelist);
			filelist.forEach(function(file)
			{			
				var f = new File(file.name,file.formats);				
				f.validateMeta();
			});
		}
	});
	$.ajaxSetup({async: true});
}

// This checks if the file actualy exists on the server.
function file_fileExists(file)
{
	var ret;
	$.ajaxSetup({async: false});
	$.post( "php/scandir.php", {"action" : "exists", "filename" : file})
	.done(function( message ) 
	{
		var infos = $.parseJSON(message);
		if(infos.success)
			ret= true;
		else
			ret= false;
	});
	$.ajaxSetup({async: true});
	
	return ret;
}

// Fully rewrite the meta-data with the current configuration.
function file_updateMetaInf()
{
	var i = 0;
	var metainf = "[";
	
	for(i = 0; i < files.length; i++)
	{
		if(i != 0)
			metainf+=",";
		metainf+=files[i].getMetaInf();
	}
	metainf+="]";
	
	
	$.post( "php/uploadmeta.php", {"action" : "replace", "metainf" : metainf})
	.done(function( message ) 
	{
		var infos = $.parseJSON(message);
		if(!infos.success)
			menu_log(infos.error,"file_updateMetaInf");
	});
}
// When a file is uploaded, the user is asked to choose the format it is.
// If the format is "UNKNOWN", the uploaded file is deleted from the server,
// else it is moved in the right folder.

function file_setUploadedFileFormat(format)
{
	var valid = new RegExp("[A-Z]+");
	
	if(!valid.test(format))
	{
		format = "UNKNOWN";
	}
	
	$.post( "php/upload.php", {"action" : "setFormat", "format" : format})
	.done(function( message ) 
	{
		var infos = $.parseJSON(message);
		if(!infos.success)
			menu_log(infos.error,"file_setUploadedFileFormat","red");
		else
		{
			file_addFile(infos.name,infos.format);
		}
	});
}

function file_addFile(name,formats)
{
	var added = false;
	for(i = 0; i < files.length; i++)
	{
		if(files[i].name == name)
		{					
			files[i].allFormat.push(formats);
			files[i].addFormat(formats);	
			added = true;
		}
	}
	if(!added)
	{
		var farray = new Array();
		farray.push(formats);
		var f = new File(name, farray);
		file_updateMetaInf();
	}
	else
	{
		file_updateMetaInf();
	}
}

// Sets up the uploading ajax transmission :
function file_uploadingSetup()
{
    var options = 
	{
		beforeSend: function()
		{ // Add something to do.
		},
		uploadProgress: function(event, position, total, percentComplete)
		{ // Add something to do.	 
		},
		success: function()
		{ // Add something to do.
		},
		complete: function(response)
		{
			var infos = $.parseJSON(response.responseText);
			
			if(infos.success)
			{
				menu_log(infos.message,"Upload","green");				
				$("#file_format_dialog").dialog("open");
			}
			else
			{
				menu_log(infos.message,"Upload","red");
			}
		},
		error: function()
		{ // Add something to do.	 
		} 
	};
	
    $("#upload_form").ajaxForm(options);
	
	 $( "#file_format_dialog" ).dialog({
		autoOpen: false,
		height: 300,
		width: 350,
		modal: true,
		buttons: {
			"Ok": function() 
			{
				file_setUploadedFileFormat($("#upload_file_format").val());
				$( this ).dialog( "close" );
			}
		},
		Cancel: function() 
		{
			$( this ).dialog( "close" );
		}
		}
		);
}
