// Setup code :
function menu_setup()
{
	$(".menu_button").click(function()
	{
		if($(this).hasClass("activated"))
		{
			$(this).removeClass("activated");				
			$("#"+$(this).attr("target")).removeClass("activated");
			$("#"+$(this).attr("target")).find(".activated").removeClass("activated");
		}
		else
		{
			$(this).parent().children(".menu_button").removeClass("activated"); // It deactivate all the buttons in the same menu.
			$(this).addClass("activated");
			$(this).parent().children(".menu_button").each(function()
			{
				$("#"+$(this).attr("target")).removeClass("activated");
				$("#"+$(this).attr("target")).find(".activated").removeClass("activated");
			});
			
			$("#"+$(this).attr("target")).addClass("activated");
		}
	});
	menu_setupDelete();
	menu_setupDownload();
	menu_setupConvert();
}

function menu_setupDelete()
{
	$("#delete_confirm_button").click(function()
	{
		var file_list = file_getSelected();
		if(file_list.length > 0)
		{
			$.post( "php/delete.php", {"file_list" : file_list})
			.done(function( message ) 
			{
				menu_log(message,"Delete","red");
				file_checkMetaInf();
			});
		}
		else
		{
			menu_log("You must select files first.","Delete","red");			 
		}
		$("#delete_button").click();
	});
	$("#delete_cancel_button").click(function()
	{
		$("#delete_button").click();
	});
}

function menu_setupDownload()
{
	$("#download_separately_button").click(function()
	{
		var file_list = file_getSelected();
		if(file_list.length > 0)
		{
			file_list.forEach(function(file)
			{
				$.post( "php/download.php", {"mode" : "single", "file" : file})
				.done(function( message ) 
				{
					var infos = $.parseJSON(message);
					if(infos.success)
					{
						$.fileDownload(infos.url); // If the file exist the "infos.url" will be the file's.
						menu_log("Download started.","Download","green");
					}
					else
						menu_log(infos.error,"Download","red");
						
				});
			});
		}
		else
		{
			menu_log("You must select files first.","Download","red");
		}
		
		$("#download_button").click();
				
	});
	$("#download_zip_button").click(function()
	{
		var file_list = file_getSelected();
		if(file_list.length > 0)
		{
			$.post( "php/download.php", {"mode" : "zip", "files" : files}) // This post will ask for the server to make an archive and it will be sent back its url.
			.done(function( message ) 
			{
				var infos = $.parseJSON(message);
				if(infos.success)
				{
					$.fileDownload(infos.url);
					menu_log("Download started.","Download","green");
				}
				else
					menu_log(infos.error,"Download","red");
			});
		}
		else
		{
			menu_log("You must select files first.","Download","red");
		}
		
		$("#download_button").click();					
	});
}

var known_formats;

function menu_setupConvert()
{
	$.ajaxSetup({async: false});
	$.post( "php/formatmeta.php", {"action" : "get"}) // Gets the metainf about known formats.
	.done(function( message ) 
	{
		var infos = $.parseJSON(message);
		if(infos.success)
		{
			known_formats = $.parseJSON(infos.formats);
		}
		else
			menu_log(infos.error,"menu_setupConvert","red"); // Manque l'appel pour transformer en liste le conteneur !!!
	});
	$.ajaxSetup({async: true});
		
	var i;
	for(i = 0; i < known_formats.length; i++)
	{		
		$("#convert_submenu").append("<li id=\"convert_"+known_formats[i][0]+"\" class=\"ui-selectee\" name=\""+known_formats[i][0]+"\">"+known_formats[i][0]+"</li>"); // Add all the types to the list.
	}
	
	$("#convert_button").click(function()
	{
		$("#convert_subsubmenu").removeClass("activated");
		$("#convert_submenu").find(".ui-selected").removeClass("ui-selected");
	});
	
	$("#convert_submenu").selectable
	({
		selected : function() 
		{ 
			if(!$("#convert_submenu").hasClass("activated"));
			{
				$("#convert_subsubmenu").addClass("activated"); 
			}
		},
		unselected : function()
		{
			if($("#convert_submenu .ui-selected").size() == 0)
			{				
				$("#convert_subsubmenu").removeClass("activated");
			}
		}
	});
	
	$("#convert_run_button").click(function()
	{
		var files = file_getSelected();
		
		var types =  new Array();
		$("#convert_submenu .ui-selected").each(function()
		{
			for(i = 0; i < known_formats.length; i++)
			{
				if($(this).attr("name") == known_formats[i][0])
					types.push(known_formats[i]);
			}			
		});
		
		$.post( "php/convert.php", {"targets" : types, "files" : files}) 
		.done(function( message ) 
		{	
			var infos = $.parseJSON(message);
			if(!infos.success) // Global fail.
			{	
				menu_log(infos.error,"Convert","red");
			}
			else
			{
				if(infos.refused.length >0) // File related fail.
				{
					menu_log(infos.refused.length+" files hasn't been converted.","Convert","red");
					$("#message").html(infos.refused);
				}
			
				if(infos.results.length >0)	// Well done job.
				{	
					var i;
					for(i = 0; i < infos.results.length; i++)
					{
						file_addFile(infos.results[i][0], infos.results[i][1]);
					}
				}
			}
			
		});
		$("#convert_subsubmenu").removeClass("activated");
		$("#convert_submenu").find(".ui-selected").removeClass("ui-selected");
	});
}

function menu_log(message,type,color)
{
	$("#message").append("<font color='"+color+"'><i>["+type+"]</i>"+message+"</font><br/>");
	$("#message").scrollTop($("#message").scrollTop()+$("#message font").height());
}