<?php

	Define("__OUTPUT_DIR","../uploads/");
	Define("__CONVERT_DIR","../ant/output/");
	Define("__SCRIPT_DIR","../ant/");
	Define("__CONVERT_DIR_FOR_ANT","./output/");
	Define("__FILE_SIZE_LIMIT",pow(2,20)); // 1Mo 

function check_file($file) // Returns a list of each possible formats for a given file. 
{
	$possible_formats = array();
	$script_dir = scandir(__SCRIPT_DIR);
	
	foreach( $script_dir as $element)
	{
		if(substr($element,-3) == "ant") // For each ant script ( named like this : xxx_to_yyy.ant )
		{
			$scriptname = __SCRIPT_DIR.$element;
			
			$output_array = array();
			$return_code = 0;
			exec( "ant -buildfile ".$scriptname." -DInputPath=\"".$file."\" match" , $output_array, $return_code); // Calls the "match" target.
			if($return_code == 0) // If it matches, we add the input format to the list.
			{
				$tmp = split("_",$element);
				array_push($possible_formats, $tmp[0]); // If the .ant file is well named we get the input format it needs. 
			}
		}
	}
	return $possible_formats;
}
 
if(isset($_FILES["file"]))
{
    if ($_FILES["file"]["error"] > 0)
    {
	  $return = array("success" => false,
					  "message" => $_FILES["file"]["error"]."<br>");
      echo json_encode($return);
    }
    else
    {
		// Testing the file :
			// Is it already uploaded on the server ? :
			$uploaded_files = scandir(__OUTPUT_DIR);
			foreach($uploaded_files as $file)
			{
				if($file == $_FILES["file"]["name"])
				{
					$return = array("success" => false,
									"message" => "This file has already been uploaded.<br>");
					echo json_encode($return);
					exit(0);
				}					
			}
			// Is it too big ?
			if($_FILES["file"]["size"] > __FILE_SIZE_LIMIT)
			{
				$return = array("success" => false,
								"message" => "This file is too large (max ".__FILE_SIZE_LIMIT." o.<br>");
				echo json_encode($return);
				exit(0);
			}
			// Do we support this kind of file ? :
			$possible_formats = check_file($_FILES["file"]["name"]);

		// We can finally save the file :
        move_uploaded_file($_FILES["file"]["tmp_name"],__OUTPUT_DIR."Unknown/". $_FILES["file"]["name"]);
		
		$return = array("success" => true,
						"message" => $_FILES["file"]["name"]." have been succesfully uploaded !<br/>",
						"filename" => $_FILES["file"]["name"],
						"format" => $possible_formats);
		echo json_encode($return);
    }
 
}
else if(isset($_POST["action"]))
{
	if($_POST["action"] == "setFormat")
	{
		$list = scandir(__OUTPUT_DIR."Unknown/");
		$list = array_slice($list,2,count($list)-2); // Pushes out . and ..
		
		$ext = pathinfo($list[0], PATHINFO_EXTENSION);
		$filename = pathinfo($list[0], PATHINFO_FILENAME);
		
		if($_POST["format"] != "UNKNOWN")
		{
			if(!is_dir(__OUTPUT_DIR.$_POST["format"]))
			{
				mkdir(__OUTPUT_DIR.$_POST["format"]);
			}
			if(file_exists(__OUTPUT_DIR.$_POST["format"].$list[0]))
			{
				unlink(__OUTPUT_DIR.$_POST["format"].$list[0]);
			}
			rename(__OUTPUT_DIR."Unknown/".$list[0],__OUTPUT_DIR.$_POST["format"]."/".$list[0]);
			$return = array("success" => true,
					"message" => "File added.",
					"name" => $filename,
					"format" => array($_POST["format"],$ext));					
			echo json_encode($return);			
		}
		else
		{
			unlink(glob(__OUTPUT_DIR."Unknown/*"));
			$return = array("success" => false,
					"message" => "File removed.",
					"name" => $filename,
					"formats" => array($_POST["format"],$ext));					
			echo json_encode($return);
		}
	}
	else
	{
		$return = array("success" => false,
						"message" => "Bad request.");					
		echo json_encode($return);
	}
}
else
{
	$return = array("success" => false,
					"message" => "No file has been received.<br>");
    echo json_encode($return);
}
?>